#include "../include/BootLoader/boot_loader.hpp"
#include <stdio.h>

namespace JabyEngine {
    static NextRoutine execute(NextRoutine routine) {
        // Support currently only direct call
        return reinterpret_cast<MainRoutine>((routine.value & ~JabyEngine::NextRoutine::OverlayBit))();
    }

    void start() {
        NextRoutine next_routine = JabyEngine::NextRoutine::from(boot::Start::setup);

        printf("Starting Planschbecken 0x%p\n", next_routine.value);
        while(true) {
            if(next_routine.is_null()) {
                break;
            }

            if(next_routine.is_overlay()) {
                printf("Overlay not supported yet!\n");
                break;
            }

            next_routine = execute(next_routine);
        }
        printf("Stop!\n");
    }
}