use super::{Error, Write};

pub fn write_generic<T>(output: &mut dyn Write, value: T) -> Result<usize, Error> {
    let raw = unsafe {std::slice::from_raw_parts(&value as *const _ as *const u8, std::mem::size_of_val(&value))};

    Error::try_or_new(output.write(raw))
}